Index: ieee80211.c
===================================================================
RCS file: /home/ncvs/src/sys/net80211/ieee80211.c,v
retrieving revision 1.11
diff -u -p -r1.11 ieee80211.c
--- ieee80211.c	2 Apr 2004 20:19:20 -0000	1.11
+++ ieee80211.c	5 May 2004 01:32:39 -0000
@@ -60,6 +60,7 @@ __FBSDID("$FreeBSD: src/sys/net80211/iee
 #include <net/if_arp.h>
 #include <net/ethernet.h>
 #include <net/if_llc.h>
+#include <net/route.h>
 
 #include <net80211/ieee80211_var.h>
 
@@ -534,11 +535,15 @@ ieee80211_media_status(struct ifnet *ifp
 {
 	struct ieee80211com *ic = (void *)ifp;
 	struct ieee80211_node *ni = NULL;
+	int old_status = imr->ifm_status;
 
 	imr->ifm_status = IFM_AVALID;
 	imr->ifm_active = IFM_IEEE80211;
-	if (ic->ic_state == IEEE80211_S_RUN)
+	if (ic->ic_state == IEEE80211_S_RUN) {
 		imr->ifm_status |= IFM_ACTIVE;
+		ifp->if_link_state = LINK_STATE_UP;
+	} else
+		ifp->if_link_state = LINK_STATE_DOWN;
 	imr->ifm_active |= IFM_AUTO;
 	switch (ic->ic_opmode) {
 	case IEEE80211_M_STA:
@@ -578,6 +583,10 @@ ieee80211_media_status(struct ifnet *ifp
 				|  IFM_IEEE80211_TURBO;
 		break;
 	}
+
+	/* Notify that the link state has changed. */
+	if (imr->ifm_status != old_status)
+		rt_ifmsg(ifp);
 }
 
 void
